GET /api/alt-fuel-stations/v1/nearest
Return the nearest alternative fuel stations within a distance of a given location.
Request URL
Request Parameters
The following query parameters may be passed in the request to control the output:
| Parameter | Required | Value | Description | ||||||||||||||||||||||||||||||||||||||||||
|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
| format | Yes |
Type: string
Default: None
Options: json, xml, csv
|
The output response format. Given in the URL as the file extension. |
||||||||||||||||||||||||||||||||||||||||||
| api_key | Yes |
Type: string
Default: None
|
Your developer API key. See API key usage for more information. |
||||||||||||||||||||||||||||||||||||||||||
| location | Depends |
Type: string
Default: None
|
A free-form input describing the address of the location. This may include the address given in a variety of formats, such as:
(Either the location parameter or both the latitude and longitude parameters are required) |
||||||||||||||||||||||||||||||||||||||||||
| latitude | Depends |
Type: decimal
Default: -90 to 90
|
The latitude of the desired location. (Either the location parameter or both the latitude and longitude parameters are required) |
||||||||||||||||||||||||||||||||||||||||||
| longitude | Depends |
Type: decimal
Default: -180 to 180
|
The longitude of the desired location. (Either the location parameter or both the latitude and longitude parameters are required) |
||||||||||||||||||||||||||||||||||||||||||
| radius | No |
Type: decimal
Default: 5.0
|
The radius (in miles) around the search location to search for stations within. | ||||||||||||||||||||||||||||||||||||||||||
| status | No |
Type: string
Default: all
Options: all, E, P
|
Return stations that match the given status. A single status, or a comma-separated list of multiple statuses, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| access | No |
Type: string
Default: all
Options: all, public, private
|
Return stations with the given access type. |
||||||||||||||||||||||||||||||||||||||||||
| fuel_type | No |
Type: string
Default: all
Options: all, BD, CNG, E85, ELEC, HY, LNG, LPG
|
Return stations that supply any of the given fuel types. A single fuel type, or a comma-separated list of multiple fuel types, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| cards_accepted | No |
Type: string
Default: all
Options: all, A, D, M, V, Cash, Checks, CFN, CleanEnergy, FuelMan, GasCard, PHH, Voyager, Wright_Exp
|
Return stations that accept any of the given payment methods. A single payment method, or a comma-separated list of multiple payment methods, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| owner_type | No |
Type: string
Default: all
Options: all, FG, LG, P, SG, T
|
Return stations owned by the given types of owners. A single owner type, or a comma-separated list of multiple owner types, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| federal_agency_id | No |
Type: integer
Default: all
Options: all, (see table to right for IDs)
|
Return stations owned by the given federal agency. A federal agency ID, or a comma-separated list of multiple federal agency IDs, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| ev_network | No |
Type: string
Default: all
Options: all, Blink Network, ChargeNet, ChargePoint Network, eVgo Network, EVSE LLC WebNet, RechargeAccess, Rideshare Online, Shorepower
|
Return only electric charging stations that belong to the given network. A single network, or a comma separate list of multiple networks, may be given.
|
||||||||||||||||||||||||||||||||||||||||||
| ev_charging_level | No |
Type: string
Default: all
Options: all, 1, 2, dc_fast
|
Return only electric charging stations that provide the given level of electric vehicle supply equipment (EVSE).
|
||||||||||||||||||||||||||||||||||||||||||
| state | No |
Type: string
Default: None
|
Return only stations within the given state. State must be given as a two character state code (eg, "CO" for Colorado). A single state, or a comma-separate list of multiple states, may be given. | ||||||||||||||||||||||||||||||||||||||||||
| zip | No |
Type: string
Default: None
|
Return only stations within the given ZIP code. ZIP codes must be exactly 5 digits long. A single ZIP code, or a comma-separate list of multiple ZIP codes, may be given. | ||||||||||||||||||||||||||||||||||||||||||
| limit | No |
Type: integer
Default: None
Minimum: 1
|
The maximum number of results to return. | ||||||||||||||||||||||||||||||||||||||||||
| offset | No |
Type: integer
Default: 0
Minimum: 0
|
Offset the results found (can be used with the limit parameter to paginate the results). |
Response Fields
The response is composed of the fuel stations matching the requested query. For JSON or XML formats, additional metadata is supplied in the following structure:
| Field | Value | Description |
|---|---|---|
| total_results |
Type: integer
|
How many total stations match your requested query (regardless of any "limit" applied). |
| offset |
Type: integer
|
The result offset applied to this query (if the "offset" parameter was given). |
| station_locator_url |
Type: string
|
The URL of the Alternative Fueling Station Locator, the web application that supplies this data. |
| latitude | Type: decimal | The latitude of the given location. This either matches the "latitude" parameter passed in, or is the geocoded latitude of the "location" parameter. |
| longitude | Type: decimal | The longitude of the given location. This either matches the "longitude" parameter passed in, or is the geocoded longitude of the "location" parameter. |
| precision | Type: record | Details on the precision of the geocoded "location" parameter (if given). See precision record fields for response details. |
| fuel_stations |
Type: array
|
An array of matching fuel station records returned in order of ascending distance from the given location. See fuel station record fields for response details. |
Fuel Station Record Fields
The individual fuel station records are returned in order of ascending distance from the given location. Each station has the following attributes:
| Field | Value | Description | ||||||||||||||||||||||||||||
|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
| fuel_type_code |
Type: string
|
The type of alternative fuel the station provides. Fuel types are given as code values as described below:
|
||||||||||||||||||||||||||||
| station_name |
Type: string
|
The name of the station. | ||||||||||||||||||||||||||||
| street_address |
Type: string
|
The street address of the station's location. | ||||||||||||||||||||||||||||
| intersection_directions |
Type: string
|
Brief additional information about how to locate the station. | ||||||||||||||||||||||||||||
| city |
Type: string
|
The city of the station's location. | ||||||||||||||||||||||||||||
| state |
Type: string
|
The two character U.S. state or Canadian province code of the station's location. | ||||||||||||||||||||||||||||
| zip |
Type: string
|
The ZIP code (postal code) of the station's location. | ||||||||||||||||||||||||||||
| plus4 |
Type: string
|
The plus-4 portion of the station's ZIP code (U.S. ZIP codes only). | ||||||||||||||||||||||||||||
| station_phone |
Type: string
|
The phone number of the station. | ||||||||||||||||||||||||||||
| status_code |
Type: string
|
The current status of the station, given as code values as described below:
|
||||||||||||||||||||||||||||
| expected_date |
Type: date
|
For planned stations, the date the station is expected to open or start carrying alternative fuel. | ||||||||||||||||||||||||||||
| groups_with_access_code |
Type: string
|
A description of who is allowed to access the station and other station access information. Stations with the groups_with_access_code "Private - fleet customers only" may allow other entities to fuel through a business-to-business arrangement. For more information, fleet customers should refer to the access_days_time field for contact information or contact the station directly. | ||||||||||||||||||||||||||||
| access_days_time |
Type: string
|
Hours of operation for the station. | ||||||||||||||||||||||||||||
| cards_accepted |
Type: string
|
A space-separated list of payment methods accepted. Payment methods are given as code values as described below:
|
||||||||||||||||||||||||||||
| owner_type_code |
Type: string
|
A space-separated list of payment methods accepted. Payment methods are given as code values as described below:
|
||||||||||||||||||||||||||||
| federal_agency |
Type: record
|
If the station is owned by a federal agency, a record for the federal agency that owns this station. See federal agency record fields for response details. | ||||||||||||||||||||||||||||
| bd_blends |
Type: string
|
For biodiesel stations, the level of biodiesel blends the station provides. | ||||||||||||||||||||||||||||
| e85_blender_pump |
Type: boolean
|
For E85 stations, an indication of whether the station has a blender pump on site, given as a boolean:
|
||||||||||||||||||||||||||||
| lpg_primary |
Type: boolean
|
For propane stations, the type of station, given as a boolean:
|
||||||||||||||||||||||||||||
| ng_fill_type_code |
Type: string
|
For CNG stations, the type of dispensing capability available, given as code values as described below:
|
||||||||||||||||||||||||||||
| ng_psi |
Type: string
|
For CNG stations, a space separated list of PSI pressures available. | ||||||||||||||||||||||||||||
| ng_vehicle_class |
Type: string
|
For CNG and LNG stations, the maximum vehicle size that can physically access the fueling infrastructure, given as code values as described below:
Note: This field does not take into account station capacity or other considerations. |
||||||||||||||||||||||||||||
| ev_level1_evse_num |
Type: integer
|
For electric stations, the number of Level 1 EVSE (standard 110V outlet). | ||||||||||||||||||||||||||||
| ev_level2_evse_num |
Type: integer
|
For electric stations, the number of Level 2 EVSE (J1772 connector). | ||||||||||||||||||||||||||||
| ev_dc_fast_num |
Type: integer
|
For electric stations, the number of DC Fast Chargers. | ||||||||||||||||||||||||||||
| ev_other_evse |
Type: string
|
For electric stations, the number and type of additional EVSE, such as:
|
||||||||||||||||||||||||||||
| ev_network |
Type: string
|
For electric stations, the name of the EVSE network, if applicable. | ||||||||||||||||||||||||||||
| ev_network_web |
Type: string
|
For electric stations, the EVSE network Web site, if applicable. | ||||||||||||||||||||||||||||
| hy_status_link |
Type: string
|
For hydrogen stations, a link to a website that provides up-to-date information about the current status of this hydrogen station. | ||||||||||||||||||||||||||||
| geocode_status |
Type: string
|
A rating indicating the approximate accuracy of the latitude and longitude for the station's address, given as code values as described below:
|
||||||||||||||||||||||||||||
| latitude |
Type: decimal
Range: -90 to 90
|
The latitude of the station's address (see the "Geocode Status" field for details on the latitude's accuracy). | ||||||||||||||||||||||||||||
| longitude |
Type: decimal
Range: -180 to 180
|
The longitude of the station's address (see the "Geocode Status" field for details on the longitude's accuracy). | ||||||||||||||||||||||||||||
| open_date |
Type: date
|
The date that the station began offering the fuel. Please note that LPG (propane) stations do not have open dates. | ||||||||||||||||||||||||||||
| date_last_confirmed |
Type: date
|
The date the station's details were last confirmed. | ||||||||||||||||||||||||||||
| updated_at |
Type: datetime
|
The time the station's details were last updated (ISO 8601 format). | ||||||||||||||||||||||||||||
| id |
Type: integer
|
A unique identifier for this specific station. | ||||||||||||||||||||||||||||
| distance |
Type: decimal
|
The distance, in miles, from the given location and this station. |
Federal Agency Record Fields
| Field | Value | Description |
|---|---|---|
| id |
Type: integer
|
A unique identifier for the federal agency. |
| name |
Type: string
|
The name of the federal agency. |
Precision Record Fields
| Field | Value | Description |
|---|---|---|
| name |
Type: string
|
A textual code for the accuracy of the geocoded location. |
| value |
Type: integer
|
A numeric code for the accuracy of the geocoded location. These generally match the Google Geocoding API V2 accuracy values. |
| types |
Type: array
|
An array of strings describing the type of location matched. These refer to the Google Geocoding API V3 address component types. |
Examples
JSON Output Format
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 |
{
"fuel_stations": [
{
"access_days_time": null,
"bd_blends": null,
"cards_accepted": null,
"city": "Golden",
"date_last_confirmed": "2012-12-31",
"expected_date": null,
"fuel_type_code": "ELEC",
"geocode_status": "200-8",
"groups_with_access_code": "Private access only",
"hy_status_link": null,
"intersection_directions": "Building 17",
"latitude": 39.7408399,
"longitude": -105.1685277,
"open_date": "2011-05-20",
"owner_type_code": "FG",
"plus4": null,
"station_name": "National Renewable Energy Laboratory - Denver West",
"station_phone": null,
"status_code": "E",
"street_address": "15013 Denver West Pkwy",
"zip": "80401",
"state": "CO",
"ng_fill_type_code": null,
"ng_psi": null,
"ng_vehicle_class": null,
"e85_blender_pump": null,
"ev_level1_evse_num": null,
"ev_level2_evse_num": 38,
"ev_dc_fast_num": null,
"ev_other_evse": null,
"ev_network": null,
"ev_network_web": null,
"lpg_primary": null,
"id": 39534,
"updated_at": "2013-01-16T16:09:02Z",
"distance": 0.92673,
"federal_agency": {
"id": 8,
"name": "U.S. Department of Energy"
}
}
],
"latitude": 39.744696,
"longitude": -105.15186,
"offset": 0,
"precision": {
"name": "address",
"types": [
"street_address"
],
"value": 8
},
"station_locator_url": "http://www.afdc.energy.gov/afdc/locator/stations/",
"total_results": 12
}
|
XML Output Format
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 |
<?xml version="1.0" encoding="UTF-8"?>
<response>
<latitude>39.744696</latitude>
<longitude>-105.15186</longitude>
<precision>
<name>address</name>
<types type="array">
<type>street_address</type>
</types>
<value type="integer">8</value>
</precision>
<station-locator-url>http://www.afdc.energy.gov/afdc/locator/stations/</station-locator-url>
<total-results>12</total-results>
<offset>0</offset>
<fuel-stations type="array">
<fuel-station>
<access-days-time nil="true" />
<bd-blends nil="true" />
<cards-accepted nil="true" />
<city>Golden</city>
<date-last-confirmed>2012-12-31</date-last-confirmed>
<expected-date nil="true" />
<fuel-type-code>ELEC</fuel-type-code>
<geocode-status>200-8</geocode-status>
<groups-with-access-code>Private access only</groups-with-access-code>
<hy-status-link nil="true" />
<intersection-directions>Building 17</intersection-directions>
<latitude>39.7408399</latitude>
<longitude>-105.1685277</longitude>
<open-date>2011-05-20</open-date>
<owner-type-code>FG</owner-type-code>
<plus4 nil="true" />
<station-name>National Renewable Energy Laboratory - Denver West</station-name>
<station-phone nil="true" />
<status-code>E</status-code>
<street-address>15013 Denver West Pkwy</street-address>
<zip>80401</zip>
<state>CO</state>
<ng-fill-type-code nil="true" />
<ng-psi nil="true" />
<ng-vehicle-class nil="true" />
<e85-blender-pump nil="true" />
<ev-level1-evse-num nil="true" />
<ev-level2-evse-num>38</ev-level2-evse-num>
<ev-dc-fast-num nil="true" />
<ev-other-evse nil="true" />
<ev-network nil="true" />
<ev-network-web nil="true" />
<lpg-primary nil="true" />
<id>39534</id>
<updated-at>2013-01-16T16:09:02Z</updated-at>
<distance>0.92673</distance>
<federal-agency>
<id type="integer">8</id>
<name>U.S. Department of Energy</name>
</federal-agency>
</fuel-station>
</fuel-stations>
</response>
|
CSV Output Format
1 2 |
Fuel Type Code,Station Name,Street Address,Intersection Directions,City,State,ZIP,Plus4,Station Phone,Status Code,Expected Date,Groups With Access Code,Access Days Time,Cards Accepted,BD Blends,NG Fill Type Code,NG PSI,EV Level1 EVSE Num,EV Level2 EVSE Num,EV DC Fast Count,EV Other Info,EV Network,EV Network Web,Geocode Status,Latitude,Longitude,Date Last Confirmed,ID,Distance,Updated At,Owner Type Code,Federal Agency ID,Federal Agency Name,Open Date,Hydrogen Status Link,NG Vehicle Class,LPG Primary,E85 Blender Pump
ELEC,National Renewable Energy Laboratory - Denver West,15013 Denver West Pkwy,Building 17,Golden,CO,80401,,,E,,Private access only,,,,,,,38,,,,,200-8,39.7408399,-105.1685277,2012-12-31,39534,0.92673,2013-01-16 16:09:02 UTC,FG,8,U.S. Department of Energy,2011-05-20,,,,
|
Rate Limits
Standard rate limits apply. No more than 1,000 requests may be made in any hour. No more than 10,000 requests may be made in any day.
Errors
Standard errors may be returned. In addition, the following service-specific errors may be returned:
| HTTP Status Code | Description |
|---|---|
| 422 | Unprocessable Entity - An invalid value was given for a query parameter. The response body will describe the specific error. |